.486
.model flat, stdcall
option casemap:none
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
.data
status          dd 0        ; to use in WriteFile
realnum         real4 0.1
realnum2        real4 0.2
;==========strings=============
str_newline     db 13, 0    


.code
start:
    jmp entry
    ; the procedures below are just for output, just ignore
    ;==========PROCEDURE write=================================
    write proc __outputstr:dword, __len:dword
        pusha
        invoke GetStdHandle, -11
        invoke WriteFile, eax, __outputstr, __len, addr status, 0
        popa
        ret
    write endp
    ;==========================================================
    ;==========PROCEDURE writeln===============================
    writeln proc __outputstr:dword, __len:dword
        invoke write, __outputstr, __len
        invoke write, addr str_newline, 2
        ret
    writeln endp
    ;==========================================================
    ;==========PROCEDURE print16===============================
    print16 proc number:dword
        pusha
        push 0
        push 0
        mov esi, esp            ; esi to save the buffer address
        mov dh, 8               ; dh as counter
        mov cl, 0               ; cl as left shift
        mov ebx, number         ; ebx to cache the number
        @@loop:     ;==-----loop-----==
            mov eax, ebx        ; set the divisor as the number
            shl eax, cl
            add cl, 4
            shr eax, 28
            cmp eax, 10
            jb @@digits
            add eax, 7
            @@digits:
            add eax, 48
            mov [esi], al
            inc esi
            dec dh
        jnz @@loop
        sub esi, 8 
        invoke write, esi, 8
        pop eax
        pop eax
        popa
        ret
    print16 endp
    ;==========================================================

entry:
    ;invoke print16, realnum ;; this is just for output, doesn't matter
    mov ecx, 1000000000
    myloop:
    fld realnum2
    fld realnum
    fmul st, st(1)
    fst realnum
    fst realnum
    dec ecx
    jnz myloop
    ;invoke print16, realnum ;; same for output
    ret
end start